/*
MDCT
apparently poor for images...
*/

#include <lz2a.h>

#include <math.h>

float mdct_min, mdct_max;
float mdct_quant[64];
float imdct_quant[64];

int MDCT_HorizBlock(byte *in, short *out)
{
	int i, j, k;
	float f, g, h;

	for(i=0; i<8; i++)
	{
		f=0;

		for(j=0; j<16; j++)
		{
			g=in[j]-128;
			g*=sin(M_PI*(j+0.5)/16);

//			h=sin(M_PI*(j+0.5)/16);
//			g*=sin(M_PI*(h*h)/2);
			f+=g*cos(M_PI*(i+0.5)*(j+0.5+4)/8);
		}
		out[i]=(short)f;

		if(f<mdct_min)mdct_min=f;
		if(f>mdct_max)mdct_max=f;
	}
}

int IMDCT_HorizBlock(short *in, byte *out)
{
	int i, j, k;
	float f, g;

	for(i=0; i<16; i++)
	{
		f=0;

		for(j=0; j<8; j++)
		{
			g=in[j];
			f+=g*cos(M_PI*(j+0.5)*(i+0.5+4)/8);
		}

		f*=sin(M_PI*(i+0.5)/16);
//		g=sin(M_PI*(i+0.5)/16);
//		f*=sin(M_PI*(g*g)/2);

		k=out[i]+(f/4);
//		k=out[i]+(f/8);
//		if(k<0)k=0;
//		if(k>255)k=255;
		out[i]=k;
	}
	for(i=0; i<8; i++)out[i]+=128;
}


int MDCT_VertBlock(short *in, short *out, int xs)
{
	int i, j;
	float f;

	for(i=0; i<8; i++)
	{
		f=0;

		for(j=0; j<16; j++)
			f+=in[j*xs]*cos(M_PI*(i+0.5)*(j+0.5+4)/8);
		out[i*xs]=(short)f;

		if(f<mdct_min)mdct_min=f;
		if(f>mdct_max)mdct_max=f;
	}
}

int IMDCT_VertBlock(short *in, short *out, int xs)
{
	int i, j, k;
	float f;

	for(i=0; i<16; i++)
	{
		f=0;

		for(j=0; j<8; j++)
			f+=in[j*xs]*cos(M_PI*(j+0.5)*(i+0.5+4)/8);
		k=out[i*xs]+(f/8);
		out[i*xs]=k;
	}
}


int MDCT_QuantizeBlock2D(short *blk, int xs)
{
	int i, j;

	for(i=0; i<8; i++)
		for(j=0; j<8; j++)
			blk[i*xs+j]*=mdct_quant[i*8+j];
}

int IMDCT_QuantizeBlock2D(short *blk, int xs)
{
	int i, j;

	for(i=0; i<8; i++)
		for(j=0; j<8; j++)
			blk[i*xs+j]*=imdct_quant[i*8+j];
}

int MDCT_FilterImage(byte *in, short *out, int xs, int ys)
{
	short *tbuf;
	int i, j;
	float f;

	mdct_min=99999;
	mdct_max=-99999;

//	tbuf=malloc(xs*ys*4);
	tbuf=out;

#if 0
	for(i=0; i<8; i++)
		for(j=0; j<8; j++)
	{
		f=sqrt(i*i+j*j);
		mdct_quant[i*8+j]=1/f;
		imdct_quant[i*8+j]=f;
	}
#endif

	for(i=0; i<ys; i++)
		for(j=0; j<(xs/8); j++)
	{
		MDCT_HorizBlock(in+(i*xs)+(j*8), tbuf+(i*xs)+(j*8));
	}

/*
	for(i=0; i<xs; i++)
		for(j=0; j<(ys/8); j++)
	{
		MDCT_VertBlock(tbuf+(j*xs*8)+i, out+(j*xs*8)+i, xs);
	}
*/

#if 0
	for(i=0; i<(ys/8); i++)
		for(j=0; j<(xs/8); j++)
	{
		MDCT_QuantizeBlock2D(out+(i*8*xs)+(j*8), xs);
	}
#endif

	printf("mdct %f %f\n", mdct_min, mdct_max);
}

int IMDCT_FilterImage(short *in, byte *out, int xs, int ys)
{
	short *tbuf;
	int i, j;

	tbuf=malloc(xs*ys*4);
	memset(tbuf, 0, xs*ys*4);

#if 0
	for(i=0; i<(ys/8); i++)
		for(j=0; j<(xs/8); j++)
	{
		IMDCT_QuantizeBlock2D(in+(i*8*xs)+(j*8), xs);
	}
#endif

/*
	for(i=0; i<xs; i++)
		for(j=0; j<(ys/8); j++)
	{
		IMDCT_VertBlock(in+(j*xs*8)+i, tbuf+(j*xs*8)+i, xs);
	}
*/

	tbuf=in;

	for(i=0; i<ys; i++)
		for(j=0; j<(xs/8); j++)
	{
		IMDCT_HorizBlock(tbuf+(i*xs)+(j*8), out+(i*xs)+(j*8));
	}
}
