typedef struct TargaHeader_s {
unsigned char 	id_length, ctype, itype;
unsigned short	cindex, clength;
unsigned char	csize;
unsigned short	x_origin, y_origin, width, height;
unsigned char	bpp, attributes;
}TargaHeader;

unsigned char *Img_LoadTGA(FILE *fd, int *w, int *h)
{
	TargaHeader head;
	int pixlin, i;
	unsigned char *dest, *src, *buf, *obuf, r, g, b, a;

	head.id_length=fgetc(fd);
	head.ctype=fgetc(fd);
	head.itype=fgetc(fd);
	head.cindex=fgetc(fd)+(fgetc(fd)<<8);
	head.clength=fgetc(fd)+(fgetc(fd)<<8);
	head.csize=fgetc(fd);
	head.x_origin=fgetc(fd)+(fgetc(fd)<<8);
	head.y_origin=fgetc(fd)+(fgetc(fd)<<8);
	head.width=fgetc(fd)+(fgetc(fd)<<8);
	head.height=fgetc(fd)+(fgetc(fd)<<8);
	head.bpp=fgetc(fd);
	head.attributes=fgetc(fd);

	if((head.itype!=2) || ((head.bpp!=32) && (head.bpp!=24)) || (head.ctype!=0))
	{
		printf("Img_LoadTGA: only RGB(24)/RGBA(32) uncompressed images supported.\n");
		printf("   bpp: %d, type: %d\n", head.bpp, head.ctype);
		return(NULL);
	}

	fseek(fd, head.id_length, 1); /* skip comment */

	pixlin=head.width*head.height;
	obuf=malloc(pixlin*4);
	dest=obuf;

	buf=malloc(pixlin*(head.bpp>>3));
	fread(buf, 1, pixlin*(head.bpp>>3), fd);
	src=buf;

	for(i=0; i<pixlin; i++)
	{
		b=*src++;
		g=*src++;
		r=*src++;
		if(head.bpp==32)
			a=*src++;
			else a=255;
		*dest++=r;
		*dest++=g;
		*dest++=b;
		*dest++=a;
	}
	free(buf);

	if(head.attributes&32)
	{
		dest=malloc(pixlin*4);
		for(i=0; i<head.height; i++)
			memcpy(&dest[i*head.width*4], &obuf[(head.height-(i+1))*head.width*4], head.width*4);
		memcpy(obuf, dest, pixlin*4);
		free(dest);
	}

	*w=head.width;
	*h=head.height;
	return(obuf);
}

int Img_StoreTGA(FILE *fd, unsigned char *buf, int w, int h)
{
	TargaHeader head;
	int i;
	unsigned char *s;

	head.id_length=0;
	head.ctype=0;
	head.itype=2;
	head.cindex=0;
	head.clength=0;
	head.csize=0;
	head.x_origin=0;
	head.y_origin=0;
	head.width=w;
	head.height=h;
	head.bpp=24;
	head.attributes=0;

	fputc(head.id_length, fd);
	fputc(head.ctype, fd);
	fputc(head.itype, fd);

	fputc(head.cindex, fd);
	fputc(head.cindex>>8, fd);
	fputc(head.clength, fd);
	fputc(head.clength>>8, fd);

	fputc(head.csize, fd);

	fputc(head.x_origin, fd);
	fputc(head.x_origin>>8, fd);
	fputc(head.y_origin, fd);
	fputc(head.y_origin>>8, fd);

	fputc(head.width, fd);
	fputc(head.width>>8, fd);
	fputc(head.height, fd);
	fputc(head.height>>8, fd);

	fputc(head.bpp, fd);
	fputc(head.attributes, fd);

//	fwrite(buf, w*4, h, fd);

	s=buf;
	for(i=0; i<w*h; i++)
	{
		fputc(s[2], fd);
		fputc(s[1], fd);
		fputc(s[0], fd);
		s+=4;
	}

	return(0);
}
